<template>
  <CdxDialog
    :open="isModalOpen"
    title="Lexeme Generator"
    close-button-label="Close"
    :primary-action="primaryAction"
    :default-action="defaultAction"
    class="text-black"
    @update:open="closeModal"
    @primary="fetchWordsAndStore"
    @default="closeModal"
  >
    <div class="mb-5">
      <p class="mb-1 font-medium">Language Wikidata Qid:</p>
      <p class="text-gray-600">{{ languageQid }}</p>
    </div>

    <div class="mb-6">
      <CdxTextInput
        v-model="matchPattern"
        class="mb-3"
        placeholder="Enter match pattern"
      />
    </div>

    <cdx-toggle-switch v-model="removeRecordedWords">
      Exclude words you have already recorded
    </cdx-toggle-switch>
  </CdxDialog>
  </template>
  
  <script setup>
  import axios from 'axios'
  import { ref } from 'vue'
  import {
    CdxButton,
    CdxDialog,
    CdxTextInput,
    CdxToggleSwitch,
  } from '@wikimedia/codex'
  
  import { useRecordWizardStore } from '@/stores/recordwizard'
  
  import getLocutorRecordings from '@/utils/getLocutorRecordings.js'
  const removeRecordedWords = ref(false)
  const datastore = useRecordWizardStore()
  const languageQid = datastore.selectedLanguageId
  
    const matchPattern = ref('');
    const isModalOpen = ref(false);
  
  const openModal = () => {
      isModalOpen.value = true;
    };
  
  const closeModal = () => {
      isModalOpen.value = false;
    };
  
  const primaryAction = {
    label: 'Run',
    actionType: 'progressive',
    };
  
  const defaultAction = {
    label: 'Cancel',
    };
  
  
  async function fetchWordsAndStore() {
    const recordWizardStore = useRecordWizardStore()
    console.log(languageQid)
    try {
      const response = await axios.get('https://query.wikidata.org/sparql', {
        params: {
          query: `SELECT ?label WHERE {
              ?id dct:language wd:${languageQid};
                  wikibase:lemma ?label
              FILTER (regex(?label, '^${matchPattern.value}.*'))
          } ORDER BY asc(?label)`,
          format: 'json',
        },
        headers: {
          Accept: 'application/json',
        },
      })
  
      let fetchedWords = response.data.results.bindings.map(
        (item) => item.label.value
      )
  
      // Exclude recorded words if toggle is enabled
      if (removeRecordedWords.value) {
        const recordedWords = await getLocutorRecordings()
        fetchedWords = fetchedWords.filter(
          (word) => !recordedWords.includes(word)
        )
      }
  
      // Adding fetched words to the store
      recordWizardStore.addWordsArray(fetchedWords)
    } catch (error) {
      console.error('Error fetching words:', error)
    }finally{
      closeModal()
    }
  }
  
  </script>
    
    
  